#         Portable Batch System (PBS) Software License
# 
# Copyright (c) 1999, MRJ Technology Solutions.
# All rights reserved.
# 
# Acknowledgment: The Portable Batch System Software was originally developed
# as a joint project between the Numerical Aerospace Simulation (NAS) Systems
# Division of NASA Ames Research Center and the National Energy Research
# Supercomputer Center (NERSC) of Lawrence Livermore National Laboratory.
# 
# Redistribution of the Portable Batch System Software and use in source
# and binary forms, with or without modification, are permitted provided
# that the following conditions are met:
# 
# - Redistributions of source code must retain the above copyright and
#   acknowledgment notices, this list of conditions and the following
#   disclaimer.
# 
# - Redistributions in binary form must reproduce the above copyright and 
#   acknowledgment notices, this list of conditions and the following
#   disclaimer in the documentation and/or other materials provided with the
#   distribution.
# 
# - All advertising materials mentioning features or use of this software must
#   display the following acknowledgment:
# 
#   This product includes software developed by NASA Ames Research Center,
#   Lawrence Livermore National Laboratory, and MRJ Technology Solutions.
# 
#         DISCLAIMER OF WARRANTY
# 
# THIS SOFTWARE IS PROVIDED BY MRJ TECHNOLOGY SOLUTIONS ("MRJ") "AS IS" WITHOUT 
# WARRANTY OF ANY KIND, AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
# FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT ARE EXPRESSLY DISCLAIMED.
# 
# IN NO EVENT, UNLESS REQUIRED BY APPLICABLE LAW, SHALL MRJ, NASA, NOR
# THE U.S. GOVERNMENT BE LIABLE FOR ANY DIRECT DAMAGES WHATSOEVER,
# NOR ANY INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
# USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 
# This license will be governed by the laws of the Commonwealth of Virginia,
# without reference to its choice of law rules.
################################################################################
# jobname: defines the layout and functions of the select job names criteria
#       dialog box.
################################################################################
proc jobname {} {
  global LABELFONT jobnameDialogBox activeWindow selv

  busy_cursor
## Bring up the standard Dialog box ##
  set jobnameDialogBox ".jobname"
  set dbox [popupDialogBox $jobnameDialogBox "Select Job Name Criteria" 1 "" "" 1]
  set activeWindow($jobnameDialogBox) 1
  set dbox_top    [lindex $dbox 0]
  set dbox_bottom [lindex $dbox 1]

## BOTTOM PART ##
  set cmdButtons \
  [buildCmdButtons $dbox_bottom {{{ok ok} {help help}}} x 2m 18 3]

  set cmdFrame  [lindex $cmdButtons 0]
  set cmdOk     [lindex $cmdButtons 1]
  set cmdHelp   [lindex $cmdButtons 2]

  $cmdHelp configure -command {xpbs_help select.jobname $jobnameDialogBox}

  $cmdOk configure -command {
  
    switch -exact -- $selv(job_option) {
      job {
        if {[string compare $selv(jobname) ""] != 0} {
          set selv(jname) "Job_Name: $selv(jobname)"
        } else {
          popupInfoBox $jobnameDialogBox "Please specify a job name."
	  return
        } 
      }
      ANY {set selv(jname) "Job_Name: -ANY-"}
    }
    destroy $jobnameDialogBox
  }


## TOP PART ##
  frame $dbox_top.header -height 10m -width 10m
  frame $dbox_top.footer -height 10m -width 10m

  frame $dbox_top.a

  frame $dbox_top.a.main
  frame $dbox_top.a.main.a
  pack $dbox_top.a -padx 2m -pady 5m

  set jobname [buildFullEntrybox $dbox_top.a.main.a 0 \
                        "" 15 "" "right" 0]
  set jobNameFrame [lindex $jobname 0]
  set jobNameLabel [lindex $jobname 1]
  set jobNameEntry [lindex $jobname 2]
  set jobNameScroll [lindex $jobname 3]
  $jobNameEntry configure -textvariable selv(jobname)
  register_default_action $jobNameEntry $cmdOk

  set radioList [list   [concat  list \"\" $jobNameFrame] \
                          {a "ANY"} ]

  set rbox [buildRadioboxes $dbox_top.a.main [list $radioList] \
                            column 12 "Job Name = "]
  set rboxFrame    [lindex $rbox 0]
  set rboxAcct     [lindex $rbox 1]
  set rboxANY      [lindex $rbox 2]

  $rboxAcct configure -variable selv(job_option) -value job -command \
    [list enable_fullentry $jobNameLabel $jobNameEntry $jobNameScroll]

  $rboxANY configure   -variable selv(job_option) -value ANY -command \
    [list disable_fullentry $jobNameLabel $jobNameEntry $jobNameScroll]

  pack forget $rboxFrame
  pack $rboxFrame -side left -anchor nw


## set DEFAULT
  set job_arg [lindex $selv(jname) 1]
  switch -exact -- $job_arg {
    "-ANY-"       {$rboxANY invoke}
    default     {
        $rboxAcct invoke
        set selv(jobname) $job_arg
    }
  }

  register_default_action $jobnameDialogBox $cmdOk

  tkwait visibility $jobnameDialogBox
  remove_busy_cursor
  catch {tkwait window $jobnameDialogBox}
  set activeWindow($jobnameDialogBox) 0
}
